/*  gngeo, a neogeo emulator
 *  Copyright (C) 2001 Peponas Thomas & Peponas Mathieu
 * 
 *  This program is free software; you can redistribute it and/or modify  
 *  it under the terms of the GNU General Public License as published by   
 *  the Free Software Foundation; either version 2 of the License, or    
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
 */

#ifdef GP2X

#include <stdarg.h>
#include "menu.h"
#include "SDL.h"
#include "SDL_image.h"
#include "messages.h"
#include "screen.h"
#include "video.h"
#include "gp2x.h"

static SDL_Surface *back;

#define COL32_TO_16(col) ((((col&0xff0000)>>19)<<11)|(((col&0xFF00)>>10)<<5)|((col&0xFF)>>3))

int gn_init_skin(void) {
	//back=IMG_Load("skin/back.png");
	back=SDL_LoadBMP("skin/back.bmp");
	if (!back) return 1;
	return 0;
}
void gn_init_pbar(char *name) {
	SDL_Rect dst_r={24,16,304,224};
	if (back) SDL_BlitSurface(back,NULL,buffer,&dst_r);
	else SDL_FillRect(buffer,NULL,COL32_TO_16(0xFAFEFB));

	SDL_textout(buffer,46,36,name);
}
void gn_popup_error(char *name,char *fmt,...) {
	char buf[512];
	va_list pvar;
	va_start(pvar,fmt);
	SDL_Event event;
	SDL_Rect dst_r={24,16,304,224};
	
	if (back) SDL_BlitSurface(back,NULL,buffer,&dst_r);
	else SDL_FillRect(buffer,NULL,COL32_TO_16(0xFE1111));

	SDL_textout(buffer,46,36,name);
	
	vsnprintf(buf,511,fmt,pvar);
	SDL_textout(buffer,62,62,buf);
	SDL_textout(buffer,170,210,"Press any key ...");

	screen_update();



	while(1) {
		SDL_WaitEvent(&event);
		switch (event.type) {
			case SDL_JOYBUTTONDOWN:
				return;
				break;
		}
	}
}
int gn_popup_question(char *name,char *fmt,...) {
	char buf[512];
	va_list pvar;
	va_start(pvar,fmt);
	SDL_Event event;
	SDL_Rect dst_r={24,16,304,224};
	
	if (back) SDL_BlitSurface(back,NULL,buffer,&dst_r);
	else SDL_FillRect(buffer,NULL,COL32_TO_16(0x11A011));

	SDL_textout(buffer,46,36,name);
	
	vsnprintf(buf,511,fmt,pvar);
	SDL_textout(buffer,62,62,buf);
	SDL_textout(buffer,170,210,"   B: Yes  X: No ");

	screen_update();



	while(1) {
		SDL_WaitEvent(&event);
		switch (event.type) {
		case SDL_JOYBUTTONDOWN:
			//joy_button[event.jbutton.which][event.jbutton.button] = 1;
			switch (event.jbutton.button) {
			case GP2X_B: return 1;
			case GP2X_X: return 0;
			default:
				break;
			}
			break;
		default:
			break;
		}
	}
}

#define NB_ITEM_2 4

static void draw_menu(GN_MENU *m) {
	SDL_Event event;
	SDL_Rect dst_r={24,16,304,224};
	int start,end,i;
	LIST *l=m->item;

	if (back) SDL_BlitSurface(back,NULL,buffer,&dst_r);
	else SDL_FillRect(buffer,NULL,COL32_TO_16(0x11A011));

	if (m->title) SDL_textout(buffer,46,36,m->title);

	start=(m->current-NB_ITEM_2>=0?m->current-NB_ITEM_2:0);
	end=(m->current+NB_ITEM_2<m->nb_elem?m->current+NB_ITEM_2:m->nb_elem);
	
	for (i=0;i<start;i++,l=l->next);
	for (i=start;i<end;i++,l=l->next) {
		GN_MENU_ITEM *m=(GN_MENU_ITEM *)l;
		SDL_textout(buffer,62,62+(i*16),m->name);
	}
}

#undef NB_ITEM_2

#endif
